Index: trunk/SophyaLib/BaseTools/randr48.cc
===================================================================
--- trunk/SophyaLib/BaseTools/randr48.cc	(revision 3888)
+++ trunk/SophyaLib/BaseTools/randr48.cc	(revision 3889)
@@ -45,4 +45,9 @@
 }
 
+/*! 
+  \brief Initialize the state of the random generator object using the integer value argument
+
+  \warning This method changes the global random generator drand48() state
+*/
 void DR48RandGen::SetSeed(long int  seed)
 {
@@ -50,8 +55,15 @@
 }
 
+/*! 
+  \brief Initialize the state of the random generator object using the short integer array
+
+  \warning This method changes the global random generator drand48() state
+*/
 void DR48RandGen::SetSeed(uint_2 seed[3])
 {
   seed48(seed);
 }
+
+//! Return the random generator state 
 void DR48RandGen::GetSeed(uint_2 seed[3])
 {
@@ -68,4 +80,9 @@
 }
 
+/*! 
+  \brief Random Initialization of the state of the random generator object using the system clock
+
+  \warning This method changes the global random generator drand48() state
+*/
 void DR48RandGen::AutoInit(int lp)
 {
@@ -185,4 +202,9 @@
 }
 
+/*! 
+  \brief Initialize the state of the random generator object using the integer value argument
+
+  \warning This method changes the global random generator drand48() state
+*/
 void ThSDR48RandGen::SetSeed(long int seed)
 {
@@ -190,35 +212,39 @@
   ths_rand->lock();
   DR48RandGen::SetSeed(seed);
+  if(!fg_nothrsafe) idx_ = rseq_.Size();
   ths_rand->unlock();
   return;
 }
 
+/*! 
+  \brief Initialize the state of the random generator object using the short integer array
+
+  \warning This method changes the global random generator drand48() state
+*/
 void ThSDR48RandGen::SetSeed(uint_2 seed[3])
 {
   if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
   ths_rand->lock();
-  SetSeed_P(seed);
+  DR48RandGen::SetSeed(seed);
+  if(!fg_nothrsafe) idx_ = rseq_.Size();
   ths_rand->unlock();
 }
 
+//! Return the random generator state 
 void ThSDR48RandGen::GetSeed(uint_2 seed[3])
 {
   if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
   ths_rand->lock();
-  GetSeed_P(seed);
+  DR48RandGen::GetSeed(seed);
   ths_rand->unlock();
   return;
 }
 
-void ThSDR48RandGen::SetSeed_P(uint_2 seed[3])
-{
-  DR48RandGen::SetSeed(seed);
-}
-
-void ThSDR48RandGen::GetSeed_P(uint_2 seed[3])
-{
-  DR48RandGen::GetSeed(seed);
-}
-
+
+/*! 
+  \brief Random Initialization of the state of the random generator object using the system clock
+
+  \warning This method changes the global random generator drand48() state
+*/
 void ThSDR48RandGen::AutoInit(int lp)
 {
@@ -245,4 +271,9 @@
     return(rseq_(idx_++));
   }
+}
+
+void ThSDR48RandGen::GetSeed_P(uint_2 seed[3])
+{
+  return DR48RandGen::GetSeed(seed);
 }
 
Index: trunk/SophyaLib/BaseTools/randr48.h
===================================================================
--- trunk/SophyaLib/BaseTools/randr48.h	(revision 3888)
+++ trunk/SophyaLib/BaseTools/randr48.h	(revision 3889)
@@ -70,7 +70,5 @@
   virtual r_8 Next();
 
-  // Non thread-safe version of Init() and GetSeed()
-  void SetSeed_P(uint_2 seed[3]);
-  void GetSeed_P(uint_2 seed[3]);
+  virtual void GetSeed_P(uint_2 seed[3]);  // Pour utilisation par PPF handler 
 
 };
Index: trunk/SophyaLib/BaseTools/stsrand.cc
===================================================================
--- trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3888)
+++ trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3889)
@@ -14,4 +14,5 @@
    \brief Random number generator
 
+   \warning This class is OBSOLETE. Use ThSDR48RandGen instead.
    This class is a thread-safe random number generator.
    Its PPF handler can be used to save the complete state of the class and the underlying
@@ -32,4 +33,7 @@
 STSRandGen::STSRandGen(size_t n, bool tsafe) 
 {
+  cout << " STSRandGen::STSRandGen()/Warning : this class is OBSOLETE. Use ThSDR48RandGen !" << endl;
+  cout << " STSRandGen::STSRandGen()/Warning : this class is OBSOLETE. Use ThSDR48RandGen !" << endl;
+
   if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
   if (tsafe) {   // thread-safe