Index: trunk/AddOn/TAcq/acqparam_exemple.d
===================================================================
--- trunk/AddOn/TAcq/acqparam_exemple.d	(revision 3922)
+++ trunk/AddOn/TAcq/acqparam_exemple.d	(revision 3923)
@@ -133,5 +133,6 @@
 ########################
 #   Niveau d'impression 
-#  @prtlev Level CounterModulo 
-prtlev 0 50000 
-prtlev 1 50000 
+#  @prtlev Level CounterModulo CounterModulo2
+#  CounterModulo2 used for BRVIsibilityCalc
+prtlev 0 50000 50 
+prtlev 1 50000 50 
Index: trunk/AddOn/TAcq/brparam.cc
===================================================================
--- trunk/AddOn/TAcq/brparam.cc	(revision 3922)
+++ trunk/AddOn/TAcq/brparam.cc	(revision 3923)
@@ -221,4 +221,5 @@
   prtlevel_=0;
   prtmodulo_=50000;
+  prtmodulo2_=50;
   Decode();    // On decode et on complete les parametres 
 }
@@ -305,5 +306,6 @@
 
   prtlevel_=p.prtlevel_;
-  prtmodulo_=p.prtlevel_;
+  prtmodulo_=p.prtmodulo_;
+  prtmodulo2_=p.prtmodulo2_;
 
   return;
@@ -399,4 +401,5 @@
     prtlevel_=conf.IParam("prtlev",0,0);
     prtmodulo_=conf.IParam("prtlev",1,50000);
+    prtmodulo2_=conf.IParam("prtlev",2,50);
   }
   
@@ -553,5 +556,5 @@
   os << " monothr y(1)/n(0) " << ((monothr)?"true":"false"); 
   os << " ActivatePattern " << ((activate_pattern)?"true":"false") <<  endl;
-  os << " PrtLevel=" << prtlevel_ << " PrtCntModulo=" <<  prtmodulo_ << endl;
+  os << " PrtLevel=" << prtlevel_ << " PrtCntModulo=" <<  prtmodulo_ << " PrtCntModulo2=" <<  prtmodulo2_ << endl;
 
   return os;
Index: trunk/AddOn/TAcq/brparam.h
===================================================================
--- trunk/AddOn/TAcq/brparam.h	(revision 3922)
+++ trunk/AddOn/TAcq/brparam.h	(revision 3923)
@@ -223,4 +223,5 @@
   int prtlevel_;
   long int prtmodulo_; 
+  long int prtmodulo2_; 
 };
 
Index: trunk/AddOn/TAcq/brviscalc.cc
===================================================================
--- trunk/AddOn/TAcq/brviscalc.cc	(revision 3922)
+++ trunk/AddOn/TAcq/brviscalc.cc	(revision 3923)
@@ -305,7 +305,8 @@
 	  POutPersist po(flnm);
 	  po << vismtx_;
-	  cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::run() NPaqProc="
-	       << totnbpaq_ << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() << " -> VisibMtx in " << flnm << endl;
-
+	  if ((prtlev_>0)&&(numfile_%prtmodulo_==0)) {
+	    cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::run() NPaqProc="
+		 << totnbpaq_ << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() << " -> VisibMtx in " << flnm << endl;
+	  }
 	  if (fgvisdt_) FillVisibTable(moyfc_, moytt_);
 	  numfile_++;
@@ -393,6 +394,8 @@
       POutPersist po(flnm);
       po << vismtx_;
-      cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::Process() NPaqProc="
-	   << totnbpaq_ << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() << " -> VisibMtx in " << flnm << endl;
+      if ((prtlev_>0)&&(numfile_%prtmodulo_==0)) {
+	cout << numfile_ << "-BRVisCalc[" << calcid_ << "/" << nbcalc_ << "]::Process() NPaqProc="
+	     << totnbpaq_ << " TotMegaFLOP=" << (uint_8)TotNbMegaFLOP() << " -> VisibMtx in " << flnm << endl;
+      }
       if (fgvisdt_) FillVisibTable(moyfc_, moytt_);
       numfile_++;
@@ -620,4 +623,10 @@
 }
 /* --Methode-- */
+void BRVisCalcGroup::SetPrintLevel(int lev, uint_8 prtmodulo)
+{
+  for(size_t i=0; i<viscalcp_.size(); i++)
+    viscalcp_[i]->SetPrintLevel(lev,prtmodulo);
+} 
+/* --Methode-- */
 void BRVisCalcGroup::start()
 {
Index: trunk/AddOn/TAcq/brviscalc.h
===================================================================
--- trunk/AddOn/TAcq/brviscalc.h	(revision 3922)
+++ trunk/AddOn/TAcq/brviscalc.h	(revision 3923)
@@ -68,4 +68,8 @@
   inline r_8 TotNbMegaFLOP() { return nb_flop_/(1024.e3); }
 
+  //---- niveau d'impression 
+  inline void SetPrintLevel(int lev=0, uint_8 prtmodulo=10) 
+    { prtlev_=lev;   prtmodulo_=prtmodulo;}
+
 protected:
   virtual void UpdateChanIds(); 
@@ -119,4 +123,6 @@
   vector< uint_8 > vndiff5tt_;  // Number of paquets having |TimeTag-TT_Fiber1|>5 per fiber 
 
+  int prtlev_;    // print level 
+  uint_8 prtmodulo_;   // print periodicity (modulo) 
 };
 
@@ -135,4 +141,5 @@
   { return viscalcp_[0]->ActivateTimeTagCheck(maxnpaq); }
   void ActivateVisDTable(bool fgfdt=false);
+  void SetPrintLevel(int lev=0, uint_8 prtmodulo=10);
 
   void start();
Index: trunk/AddOn/TAcq/mfacq.cc
===================================================================
--- trunk/AddOn/TAcq/mfacq.cc	(revision 3922)
+++ trunk/AddOn/TAcq/mfacq.cc	(revision 3923)
@@ -430,4 +430,5 @@
   VCGThr.SelectFreqBinning(acpar.freqminVisiC, acpar.freqmaxVisiC, acpar.nbinfreqVisiC);
   VCGThr.ActivateVisDTable(acpar.fgfdtVisiC);
+  VCGThr.SetPrintLevel(acpar.prtlevel_, acpar.prtmodulo2_); 
 
   cout << "mfacq[3] Creating   EthernetReader thread object     " << endl;
Index: trunk/AddOn/TAcq/racqueth.cc
===================================================================
--- trunk/AddOn/TAcq/racqueth.cc	(revision 3922)
+++ trunk/AddOn/TAcq/racqueth.cc	(revision 3923)
@@ -192,4 +192,5 @@
     // Byte* nextdma = locdata+((kmz%memgr.NbZones())*(paqsz*memgr.NbPaquets()));
   uint_4 npaqfaitg = 0; 
+  TimeStamp tsp;
 
   for (int i=0;i< (int)nbDma_ ;i++)
@@ -203,6 +204,11 @@
     if (stop_) break;
 
-    if ((prtlev_>0)&&(npaqfaitg>=prtcounter)) { 
-      cout << " PCIEToEthernet::run()/Info NPaqFait= " << npaqfaitg << endl;
+    if ((prtlev_>0)&&(npaqfaitg>=prtcounter)) {
+      if (prtlev_>1) {
+	tsp.SetNow();
+        cout << tsp << " PCIEToEthernet::run()/Info NPaqFait= " << npaqfaitg << endl;
+	for (int fib=0; fib<(int) nbDma_ ;fib++)  pcheck[fib].Print(cout);
+      }
+      else cout << " PCIEToEthernet::run()/Info NPaqFait= " << npaqfaitg << endl;
       while(prtcounter<=npaqfaitg) prtcounter+=prtmodulo_;
     }
@@ -578,7 +584,8 @@
       totnpaqrd_++;
       if ((prtlev_>0)&&(totnpaqrd_%prtmodulo_==0))  {
-	  cout << "EthernetReader: NbPaq/Link=" << totnpaqrd_ << " NSameFC=" 
-	       << totsamefc_ << " / NPaqFib0Read=" << totnpqrd_[0] 
-	       << " FracSameFC=" << 100*totsamefc_/totnpqrd_[0] << " %" <<  endl;
+	if (prtlev_>1) { ts.SetNow(); cout << ts; }
+	cout << "EthernetReader: NbPaq/Link=" << totnpaqrd_ << " NSameFC=" 
+	     << totsamefc_ << " / NPaqFib0Read=" << totnpqrd_[0] 
+	     << " FracSameFC=" << 100*totsamefc_/totnpqrd_[0] << " %" <<  endl;
       }
       if (totnpaqrd_>=par_.MaxNbPaquets()) { 